﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace OgonPhonesXML.Aastra.Serializer
{
    [System.CodeDom.Compiler.GeneratedCodeAttribute("xsd", "2.0.50727.3038")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType = true)]
    [System.Xml.Serialization.XmlRootAttribute(Namespace = "", IsNullable = false)]
    public partial class AastraIPPhoneTextMenu
    {
        private titleTagType titleField;

        private AastraIPPhoneTextMenuMenuItem[] menuItemField;
        private List<AastraIPPhoneTextMenuMenuItem> listMenuItem = new List<AastraIPPhoneTextMenuMenuItem>();

        private softKeyType[] softKeyField;
        private List<softKeyType> listSoftKey = new List<softKeyType>();

        private iconListTypeIcon[] iconListField;
        private List<iconListTypeIcon> listIconList = new List<iconListTypeIcon>();

        private string destroyOnExitField;

        private string beepField;

        private string lockInField;

        private string timeoutField;

        private string defaultIndexField;

        private string cancelActionField;

        private string styleField;

        private string allowAnswerField;

        private string wrapListField;

        private string allowDropField;

        private string allowConfField;

        private string allowXferField;

        public AastraIPPhoneTextMenu()
        {
            this.destroyOnExitField = "no";
            this.beepField = "no";
            this.lockInField = "no";
            this.timeoutField = "45";
            this.defaultIndexField = "1";
            this.styleField = "numbered";
            this.allowAnswerField = "no";
            this.wrapListField = "no";
            this.allowDropField = "no";
            this.allowConfField = "no";
            this.allowXferField = "no";
        }
        public void addTitle(string text)
        {
            titleField = new titleTagType();
            String[] finalText = { text };
            titleField.Text = finalText;
        }
        public void addTitle(string text, string wrap)
        {
            titleField = new titleTagType();
            String[] finalText = { text };
            titleField.Text = finalText;
            titleField.wrap = wrap;
        }
        public void addMenuItem(string text, string uri)
        {
            AastraIPPhoneTextMenuMenuItem psvMenuItem = new AastraIPPhoneTextMenuMenuItem();
            psvMenuItem.Prompt = text;
            psvMenuItem.URI = uri;
            listMenuItem.Add(psvMenuItem);
        }
        public void addMenuItem(string text, string uri, string dial)
        {
            AastraIPPhoneTextMenuMenuItem psvMenuItem = new AastraIPPhoneTextMenuMenuItem();
            psvMenuItem.Prompt = text;
            psvMenuItem.URI = uri;
            psvMenuItem.Dial = dial;
            listMenuItem.Add(psvMenuItem);
        }
        public void addMenuItem(string text, string uri, string dial, string icon)
        {
            AastraIPPhoneTextMenuMenuItem psvMenuItem = new AastraIPPhoneTextMenuMenuItem();
            psvMenuItem.Prompt = text;
            psvMenuItem.URI = uri;
            psvMenuItem.Dial = dial;
            psvMenuItem.icon = icon;
            listMenuItem.Add(psvMenuItem);
        }
        public void addSoftKey(string index, string label, string uri)
        {
            softKeyType psvSoftKey = new softKeyType();
            psvSoftKey.index = index;
            psvSoftKey.Label = label;

            psvSoftKey.URI = uri;
            listSoftKey.Add(psvSoftKey);
        }
        public void addSoftKey(string index, string label, string uri, string icon)
        {
            softKeyType psvSoftKey = new softKeyType();
            psvSoftKey.index = index;
            psvSoftKey.Label = label;
            psvSoftKey.icon = icon;
            psvSoftKey.URI = uri;
            listSoftKey.Add(psvSoftKey);
        }
        public void addIconList(string index, string text)
        {
            iconListTypeIcon psvIconType = new iconListTypeIcon();
            psvIconType.index = index;
            String[] finalString = { text };
            psvIconType.Text = finalString;
            listIconList.Add(psvIconType);
        }
        /// <comentarios/>
        [System.Xml.Serialization.XmlElementAttribute(Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        public titleTagType Title
        {
            get
            {
                return this.titleField;
            }
            set
            {
                this.titleField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlElementAttribute("MenuItem", Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        public AastraIPPhoneTextMenuMenuItem[] MenuItem
        {
            get
            {
                this.menuItemField = listMenuItem.ToArray();
                return this.menuItemField;
            }
            set
            {
                this.menuItemField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlElementAttribute("SoftKey", Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        public softKeyType[] SoftKey
        {
            get
            {
                this.softKeyField = listSoftKey.ToArray();
                return this.softKeyField;
            }
            set
            {
                this.softKeyField = value;
            }
        }

        /// <comentarios/>
        //[System.Xml.Serialization.XmlArrayAttribute(Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        //[System.Xml.Serialization.XmlArrayItemAttribute("Icon", Form = System.Xml.Schema.XmlSchemaForm.Unqualified, IsNullable = false)]
        [System.Xml.Serialization.XmlElementAttribute("IconList", Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        public iconListTypeIcon[] IconList
        {
            get
            {
                this.iconListField = listIconList.ToArray();
                return this.iconListField;
            }
            set
            {
                this.iconListField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("no")]
        public string destroyOnExit
        {
            get
            {
                return this.destroyOnExitField;
            }
            set
            {
                this.destroyOnExitField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("no")]
        public string Beep
        {
            get
            {
                return this.beepField;
            }
            set
            {
                this.beepField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("no")]
        public string LockIn
        {
            get
            {
                return this.lockInField;
            }
            set
            {
                this.lockInField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute(DataType = "integer")]
        [System.ComponentModel.DefaultValueAttribute("45")]
        public string Timeout
        {
            get
            {
                return this.timeoutField;
            }
            set
            {
                this.timeoutField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute(DataType = "integer")]
        [System.ComponentModel.DefaultValueAttribute("1")]
        public string defaultIndex
        {
            get
            {
                return this.defaultIndexField;
            }
            set
            {
                this.defaultIndexField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        public string cancelAction
        {
            get
            {
                return this.cancelActionField;
            }
            set
            {
                this.cancelActionField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("numbered")]
        public string style
        {
            get
            {
                return this.styleField;
            }
            set
            {
                this.styleField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("no")]
        public string allowAnswer
        {
            get
            {
                return this.allowAnswerField;
            }
            set
            {
                this.allowAnswerField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("no")]
        public string wrapList
        {
            get
            {
                return this.wrapListField;
            }
            set
            {
                this.wrapListField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("no")]
        public string allowDrop
        {
            get
            {
                return this.allowDropField;
            }
            set
            {
                this.allowDropField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("no")]
        public string allowConf
        {
            get
            {
                return this.allowConfField;
            }
            set
            {
                this.allowConfField = value;
            }
        }

        /// <comentarios/>
        [System.Xml.Serialization.XmlAttributeAttribute()]
        [System.ComponentModel.DefaultValueAttribute("no")]
        public string allowXfer
        {
            get
            {
                return this.allowXferField;
            }
            set
            {
                this.allowXferField = value;
            }
        }
    }
}
